<?php
/*
 * Author: Lachlan Hunt - http://lachy.id.au/
 * This file is released to the Public Domain.
 */

header('Content-Type: text/html; charset=UTF-8');

require_once 'encoding-functions.php';

$rawInput = '';
$utf8Data = '';

if (get_magic_quotes_gpc()) {
	$rawInput = stripslashes($_REQUEST['input']);
} else {
	$rawInput = $_REQUEST['input'];
}

if (isUTF8($rawInput)) {
	$utf8Data = $rawInput;
} else {
	$utf8Data = utf8FromCP1252($rawInput);
}

$htmlData = htmlspecialchars($utf8Data);

//$htmlData = htmlspecialchars($utf8Data, ENT_NOQUOTES, 'UTF-8');
//$htmlattrData = htmlspecialchars($utf8Data, ENT_COMPAT, 'UTF-8');

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>Encoding Conversion Test</title>
</head>
<body>

<form method="get" action="encoding-test" accept-charset="UTF-8">
<fieldset>
	<legend><code>accept-charset="UTF-8"</code></legend>
	<p>This contains some common characters from the <code>Windows-1252</code> repertoire</p>
	<p><textarea name="input" rows="5" cols="50">&#x20AC; &#x2026; &#x2018; &#x2019; &#x201C; &#x201D;</textarea></p>
	<p><input type="submit" value="Send as UTF-8"></p>
</fieldset>
</form>

<form method="get" action="encoding-test" accept-charset="ISO-8859-1">
<fieldset>
	<legend><code>accept-charset="ISO-8859-1"</code></legend>
	<p>If your browser supports the <code>accept-charset</code> attribute, this form will submit your input as <code>ISO-8859-1</code> (or <code>Windows-1252</code>).
	   If not, manually change the encoding of this page to <code>ISO-8859-1</code> or <code>Windows-1252</code>.</p>
	<p>This contains some common characters from the <code>Windows-1252</code> repertoire</p>
	<p><textarea name="input" rows="5" cols="50">&#x20AC; &#x2026; &#x2018; &#x2019; &#x201C; &#x201D;</textarea></p>
	<p><input type="submit" value="Convert to UTF-8"></p>
</fieldset>
</form>

<h1>Output</h1>
<pre><samp><?=$htmlData?></samp></pre>
<p><a href="http://validator.w3.org/check?uri=referer">Validate this page</a> to confirm that it has output valid UTF-8 characters.</p>
</body>
</html>
